// DDDemoView.cpp : implementation of the CDDDemoView class
//

#include "stdafx.h"
#include "DDDemo.h"

#include "DDDemoDoc.h"
#include "DDDemoView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDDDemoView

IMPLEMENT_DYNCREATE(CDDDemoView, CView)

BEGIN_MESSAGE_MAP(CDDDemoView, CView)
	//{{AFX_MSG_MAP(CDDDemoView)
	ON_COMMAND(ID_VIEW_ZOOMIN, OnViewZoomin)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ZOOMIN, OnUpdateViewZoomin)
	ON_COMMAND(ID_VIEW_ZOOMOUT, OnViewZoomout)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ZOOMOUT, OnUpdateViewZoomout)
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_VIEW_PROPERTIES, OnViewProperties)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PROPERTIES, OnUpdateViewProperties)
	ON_WM_RBUTTONDOWN()
	ON_WM_TIMER()
	ON_COMMAND(ID_WINDOW_FADEOUT, OnWindowFadeout)
	ON_UPDATE_COMMAND_UI(ID_WINDOW_FADEOUT, OnUpdateWindowFadeout)
	ON_COMMAND(ID_WINDOW_FADEIN, OnWindowFadein)
	ON_UPDATE_COMMAND_UI(ID_WINDOW_FADEIN, OnUpdateWindowFadein)
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDDDemoView construction/destruction

CDDDemoView::CDDDemoView() : m_nZoom(1), m_bEffectOn(FALSE), m_bHasFocus(FALSE)
{
	// TODO: add construction code here

}

CDDDemoView::~CDDDemoView()
{
}

BOOL CDDDemoView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDDDemoView drawing

void CDDDemoView::OnDraw(CDC* pDC)
{
	CDDDemoDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here

	CRect rect;
	GetClientRect(&rect);

	BITMAP bmpInfo;
#ifdef _DEBUG
	if( pDoc->m_Bitmap.GetSafeHandle() ) // Stop debuger from breaking in GetBitmap()
#endif
	if( !pDoc->m_Bitmap.GetBitmap(&bmpInfo) )
	{
		pDC->FillSolidRect(&rect, ::GetSysColor(COLOR_WINDOW));
	}
	else
	{
		CDC dcMemory;
		dcMemory.CreateCompatibleDC(pDC);

		CBitmap* pOldBitmap = dcMemory.SelectObject(&pDoc->m_Bitmap);

		int nX, zWidth  = bmpInfo.bmWidth;
		int nY, zHeight = bmpInfo.bmHeight;
		if( m_nZoom > 1 )
		{
			zWidth  *= m_nZoom;
			zHeight *= m_nZoom;
			nX = rect.left + (rect.Width() - zWidth  ) / 2;
			nY = rect.top  + (rect.Height() - zHeight) / 2;

			pDC->StretchBlt(nX, nY, zWidth, zHeight,
				&dcMemory, 0, 0, bmpInfo.bmWidth, bmpInfo.bmHeight, SRCCOPY);
		}
		else
		{
			nX = rect.left + (rect.Width() - zWidth  ) / 2;
			nY = rect.top  + (rect.Height() - zHeight) / 2;

			pDC->BitBlt(nX, nY, zWidth, zHeight,
				&dcMemory, 0, 0, SRCCOPY);
		}

		dcMemory.SelectObject(pOldBitmap);

		// Exclude image from furthur drawing
		pDC->ExcludeClipRect( nX, nY, nX + zWidth, nY + zHeight );

		// Fill window background
		pDC->FillSolidRect(&rect, ::GetSysColor(COLOR_WINDOW));

		// Exclude 1 pixels wide border around image from furthur drawing
		pDC->ExcludeClipRect( nX - 1, nY - 1, nX + zWidth + 1, nY + zHeight + 1 );

		// Draw frame around image
		--nX; --nY; zWidth+=2; zHeight+=2;
		int iFrameWidth = 4; // Just for kicks
		if( m_bHasFocus )
		{
			pDC->FillSolidRect(
				nX - iFrameWidth, nY - iFrameWidth,
				zWidth + (iFrameWidth<<1), zHeight + (iFrameWidth<<1),
				RGB(0, 0, 196) );
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDDDemoView printing

BOOL CDDDemoView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDDDemoView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDDDemoView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDDDemoView diagnostics

#ifdef _DEBUG
void CDDDemoView::AssertValid() const
{
	CView::AssertValid();
}

void CDDDemoView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDDDemoDoc* CDDDemoView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDDDemoDoc)));
	return (CDDDemoDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDDDemoView message handlers

void CDDDemoView::OnViewZoomin() 
{
	if( m_nZoom < 16 )
	{
		++m_nZoom;
		Invalidate();
	}
}

void CDDDemoView::OnUpdateViewZoomin(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_nZoom < 16);
}

void CDDDemoView::OnViewZoomout() 
{
	if( m_nZoom > 1 )
	{
		--m_nZoom;
		Invalidate();
	}
}

void CDDDemoView::OnUpdateViewZoomout(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_nZoom > 1);
}

BOOL CDDDemoView::OnEraseBkgnd(CDC* /*pDC*/) 
{
	// TODO: Add your message handler code here and/or call default
	return TRUE;
	//return CView::OnEraseBkgnd(pDC);
}

void CDDDemoView::OnViewProperties() 
{
	CDDDemoDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if( !pDoc->m_DibData.GetDibPtr() )
		return;

	LPCTSTR szCompression[] =
	{
		_T("BI_RGB"),
		_T("BI_RLE8"),
		_T("BI_RLE4"),
		_T("BI_BITFIELDS"),
		_T("BI_JPEG"),
		_T("BI_PNG")
	};

	TCHAR szBuffer[512]; // max needed approxamataly 330
	_stprintf(szBuffer,
		_T("Header Size\t= %u\n"
		   "Width\t\t= %d\n"
		   "Height\t\t= %d\n"
		   "Planes\t\t= %u\n"
		   "BitCount\t\t= %u\n"
		   "Compression\t= %s\n"
		   "SizeImage\t= %u\n"
		   "XPelsPerMeter\t= %d\n"
		   "YPelsPerMeter\t= %d\n"
		   "ClrUsed\t\t= %u\n"
		   "ClrImportant\t= %u\n"),
		   pDoc->m_DibData.GetHeaderSize(),
		   pDoc->m_DibData.GetWidth(),
		   pDoc->m_DibData.GetHeight(),
		   pDoc->m_DibData.GetPlanes(),
		   pDoc->m_DibData.GetBitCount(),
		   szCompression[pDoc->m_DibData.GetCompression()%5],
		   pDoc->m_DibData.GetSizeImage(),
		   pDoc->m_DibData.GetXPelsPerMeter(),
		   pDoc->m_DibData.GetYPelsPerMeter(),
		   pDoc->m_DibData.GetClrUsed(),
		   pDoc->m_DibData.GetClrImportant()
		);
	MessageBox(szBuffer, _T("Properties"));
}

void CDDDemoView::OnUpdateViewProperties(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable();
}

void CDDDemoView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	OnViewProperties();
	CView::OnRButtonDown(nFlags, point);
}

BOOL CDDDemoView::FadeOut()
{
	CDDDemoDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if( !pDoc->m_DibData.GetDibPtr() )
		return FALSE;

	static int n = 0;
	static RGBQUAD rgbColors[256];
	if( n >= 255 )
	{
		n = 0;
		KillTimer(ID_WINDOW_FADEOUT);
		return FALSE;
	}

	DWORD nColors = pDoc->m_DibData.GetUsedColors();
	if( n <= 0 )
	{
		LPRGBQUAD pColors = pDoc->m_DibData.GetColorTablePtr();
		if( !pColors )
			return FALSE;
		::CopyMemory(rgbColors, pColors, nColors * sizeof(RGBQUAD));
	}

	for( DWORD i = 0; i < nColors; ++i )
	{
		if( rgbColors[i].rgbBlue  > 0 )
			--rgbColors[i].rgbBlue;

		if( rgbColors[i].rgbGreen > 0 )
			--rgbColors[i].rgbGreen;

		if( rgbColors[i].rgbRed > 0 )
			--rgbColors[i].rgbRed;
	}

	HDC hdc = ::CreateCompatibleDC(NULL);
	if( hdc )
	{
		HGDIOBJ hObj = ::SelectObject(hdc, pDoc->m_Bitmap.GetSafeHandle());
		(DWORD)::SetDIBColorTable(hdc, 0, nColors, rgbColors);
		::SelectObject(hdc, hObj);
		::DeleteDC(hdc);
		
		++n;
		Invalidate();
		UpdateWindow();
		return TRUE;
	}
	return FALSE;
}

BOOL CDDDemoView::FadeIn()
{
	CDDDemoDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if( !pDoc->m_DibData.GetDibPtr() )
		return FALSE;

	static int n = 0;
	static RGBQUAD rgbColors[256];
	static struct tag_dud { int r, g, b; } dud[256];
	if( n >= 255 )
	{
		n = 0;
		KillTimer(ID_WINDOW_FADEIN);
		return FALSE;
	}

	DWORD nColors = pDoc->m_DibData.GetUsedColors();
	LPRGBQUAD pSrcColors = pDoc->m_DibData.GetColorTablePtr();
	if( !pSrcColors )
		return FALSE;

	if( n <= 0 )
	{
		::ZeroMemory(rgbColors, nColors * sizeof(RGBQUAD));
		for( DWORD i = 0; i < nColors; ++i )
		{
			dud[i].r = int(pSrcColors[i].rgbRed)   - 255;
			dud[i].g = int(pSrcColors[i].rgbGreen) - 255;
			dud[i].b = int(pSrcColors[i].rgbBlue)  - 255;
		}
	}

	for( DWORD i = 0; i < nColors; ++i )
	{
		++dud[i].r;
		++dud[i].g;
		++dud[i].b;

		if( dud[i].r >= 0 && rgbColors[i].rgbRed < pSrcColors[i].rgbRed )
			++rgbColors[i].rgbRed;

		if( dud[i].g >= 0 && rgbColors[i].rgbGreen < pSrcColors[i].rgbGreen )
			++rgbColors[i].rgbGreen;

		if( dud[i].b >= 0 && rgbColors[i].rgbBlue < pSrcColors[i].rgbBlue )
			++rgbColors[i].rgbBlue;
	}

	HDC hdc = ::CreateCompatibleDC(NULL);
	if( hdc )
	{
		HGDIOBJ hObj = ::SelectObject(hdc, pDoc->m_Bitmap.GetSafeHandle());
		(DWORD)::SetDIBColorTable(hdc, 0, nColors, rgbColors);
		::SelectObject(hdc, hObj);
		::DeleteDC(hdc);
		
		++n;
		Invalidate();
		UpdateWindow();
		return TRUE;
	}
	return FALSE;
}

void CDDDemoView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	switch( nIDEvent )
	{
	case ID_WINDOW_FADEOUT: m_bEffectOn = FadeOut(); break;
	case ID_WINDOW_FADEIN:  m_bEffectOn = FadeIn();  break;
	}

	CView::OnTimer(nIDEvent);
}

void CDDDemoView::OnWindowFadeout() 
{
	SetTimer(ID_WINDOW_FADEOUT, 20, NULL);
	m_bEffectOn = TRUE;
}

void CDDDemoView::OnUpdateWindowFadeout(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!m_bEffectOn);
}

void CDDDemoView::OnWindowFadein() 
{
	SetTimer(ID_WINDOW_FADEIN, 20, NULL);
	m_bEffectOn = TRUE;
}

void CDDDemoView::OnUpdateWindowFadein(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!m_bEffectOn);
}

void CDDDemoView::OnSetFocus(CWnd* pOldWnd) 
{
	CView::OnSetFocus(pOldWnd);
	m_bHasFocus = TRUE;
	Invalidate(FALSE);
}

void CDDDemoView::OnKillFocus(CWnd* pNewWnd) 
{
	CView::OnKillFocus(pNewWnd);
	m_bHasFocus = FALSE;
	Invalidate(FALSE);
}
